NB. jsocket_simple_server_jconsole.ijs
NB. jsocket_simple_server_jconsole_2023_09_05.ijs

NB. Yuji Suda
NB. g.ysuda@gmail.com
NB. encoding code: UTF-8

NB. The socket communication of this application is based on
NB. J's Studio->Labs->Socket Driver Server and Socket Driver - Client

NB. This application is for jconsole.exe (windows) and jconsole (mac and linux).
NB. The script is valid for qt terminal but it may fail to display messages during
NB. the operation.

NB. See. https://code.jsoftware.com/wiki/Guides/Asynchronous_GUI#J_Processing

NB. Initially, screen output messages were written in Japnaese, but finally
NB. screen out messages have been written in English in order to avoid mismatching
NB. in the encoding code of Japanese windows jconsole.exe to jconsoles of mac and linux.

NB. Encoding-code for jconsole.exe in Japanese windows is shift-JIS, whereas
NB. the code is UTF-8 in mac and linux jconsole.

NB. There are remaining commented out Japnaese messages for convenience.

NB. This server monitors specified port for connection request
NB. and once connected with client, incoming message from client
NB. are monitored and processed, in either mode of desctiptive echo back
NB. or execution as one line j command.

NB. ====================================================================================================
NB. load drivers for socket 
load 'socket'
coinsert 'jsocket'

NB. -------------------------
NB. --- some system tools ---
NB. -------------------------

NB. ====================================================================================================
NB. keyboard input string
keyin =: 3 : 0
1!:1 <1
)

NB. ====================================================================================================
NB.screen output
screen_out =: 3 : 0
y 1!:2 >2
)

NB. ====================================================================================================
NB. alternative definition
print =: screen_out

NB. ====================================================================================================
NB. scroll screen by arg mumber of lines
scroll_up_screen =: 3 : 0
rep =. 0
while. rep<y do.
  print CRLF
  rep =. rep + 1
end.
)

NB. ====================================================================================================
NB. write string to a file
write_str_to_file =: 4 : 0
x 1!:2 <y
)

NB. ====================================================================================================
NB. alternative definition
wtf =: write_str_to_file

NB. ====================================================================================================
NB. append string to a file
append_it =: 4 : 0
x 1!:3 <y
)
NB. ---------------
NB. --- globals ---
NB. ---------------

NB. ====================================================================================================
NB. the following port is the default, and it can be changed.
HOST_PORT =: '1500'

NB. -------------------------
NB. --- support finctions ---
NB. -------------------------

NB. ====================================================================================================
disp_port_monitor_server_menu =: 3 : 0
scroll_up_screen 20
print ''
print ''
print ''
print ' ======= simple server (port monitor) menu (ver 0.1) ======='
print ''
        connect_condition =. ' current PORT number = '
        connect_condition =. connect_condition, HOST_PORT 
print   connect_condition
   print ''
NB.print ' 1 port 番号の変更', CRLF
   print ' 1 change port number', CRLF
NB.print ' E サーバー起動（エコーバックモード）'
   print ' E echo back mode'
NB.print ' J サーバー起動（一行Jコマンド受付モード）', CRLF, CRLF
   print ' J J command mode (one line command only)', CRLF, CRLF
NB.print ' Q 終了'
   print ' Q Quit'
   print ''
NB.print '番号又は文字でコマンドを入力して下さい'
   print 'select your command (1, E, J, or Q)'
1
)

NB. ====================================================================================================
change_target_host_port =: 3 : 0
NB.print CRLF, '使用するポート番号を入力して下さい'
   print CRLF, 'input PORT number fro socket communication'
   a_new_port =. keyin 8
   HOST_PORT =: a_new_port
1
)

NB. ====================================================================================================
one_chr_menu_selection_server_mode =: 3 : 0  NB. good !!!!
NB. print 'keyin one chr'
NB. your_chr =. keyin 8
your_chr =. y  NB. take from arg
NB. print 'your_chr = ', your_chr
a_value =. a. i. your_chr
NB. print 'pos in the str ', ":a_value
b_value =. ":a_value
select. ".b_value
case. (a. i. '1') do.
  COMMAND_NAME =: 'change_target_host_port'
case. (a. i. 'E') do.
  SERVER_MODE =: 'echo'
  COMMAND_NAME =: 'start_port_monitor'
case. (a. i. 'e') do.
  SERVER_MODE =: 'echo'
  COMMAND_NAME =: 'start_port_monitor'
case. (a. i. 'J') do.
  SERVER_MODE =: 'jcmd'
  COMMAND_NAME =: 'start_port_monitor'
case. (a. i. 'j') do.
  SERVER_MODE =: 'jcmd'
  COMMAND_NAME =: 'start_port_monitor'
case. (a. i. 'Q') do.
  COMMAND_NAME =: 'exit_menu'
case. (a. i. 'q') do.
  COMMAND_NAME =: 'exit_menu'
case. (a. i. 'A') do.
case.  do.
  COMMAND_NAME =: ''
end.
1
)

NB. ====================================================================================================
NB. クライアントからのメッセージ受信
sdrecv_one_msg =: 3 : 0

NB. sdrecv 関数でクライアントからのメッセージを受信
r  =. sdrecv SKSERVER, SDRECV_BUFFER_SIZE, 0

NB. sderror 関数でエラーコードの取得
er =. sderror c=. >{.r

NB. クライアントからのメッセージ全体を取得し、グローバル変数 data に代入
data =. >1{r

NB. エラーコードがソケット回線切断の場合、切断のイベントを通知
if. (er -:'ECONNRESET') do.
   NB. print 'クライアントの通信切断がありました '
       print 'client disconnected communication.'
end.
NB. print 'メッセージの受信が完了しました ', CRLF
    print 'message has been recieved.', CRLF
data  NB. 受信メッセージを返す
)

NB. ====================================================================================================
prepare_response_message_echo_back_mode =: 3 : 0
NB. return message for client
NB. サーバーからクライアントへの応答メッセージの作成

NB. a_return_msg_0 =. CRLF, '以下のメッセージをありがとう。(from your server)', CRLF	   
NB. a_return_msg_1 =. '受信バイト数: ', TOTAL_BYTE_RECEIVED_IN_STR, ' bytes', CRLF
NB. a_return_msg_2 =. '受信内容    : ', MSG_FROM_CLIENT, CRLF
    a_return_msg_0 =. CRLF, 'this is Server reply message:', CRLF	   
    a_return_msg_1 =. 'server recieved: ', TOTAL_BYTE_RECEIVED_IN_STR, ' bytes', CRLF
    a_return_msg_2 =. 'content of msg : ', MSG_FROM_CLIENT, CRLF

a_return_msg_final =. a_return_msg_0, a_return_msg_1, a_return_msg_2
)

NB. ====================================================================================================
prepare_response_message_j_one_line_command_mode =: 3 : 0

a_client_j_cmd =. MSG_FROM_CLIENT

if. CR   -: _1{.a_client_j_cmd do. a_client_j_cmd =. _1 }. a_client_j_cmd end.
if. CRLF -: _2{.a_client_j_cmd do. a_client_j_cmd =. _2 }. a_client_j_cmd end.

try.
    NB. try 3!:1 for function return  NG
    NB. cmd_return =. 3!:1 a_client_j_cmd
    cmd_return =. ". a_client_j_cmd  NB. execute
    NB. もっと複雑なエラー処理が必要そう
    
    if.(":$cmd_return) -: '0 0' do.
      NB. return_msg =. '関数戻り値の　shape は 0 0で、エラーなく実行できています。', CRLF  NB. plot はこれで通過する
          return_msg =. 'shape of J function return is 0 0. this means no error in the execution', CRLF  NB. plot はこれで通過する
    else.
          return_msg =. (":cmd_return), CRLF
    end.
catch.
NB. return_msg =. CRLF, '送信された　コマンド : ', CRLF, a_client_j_cmd, CRLF, 'でエラーが発生しました。', CRLF
    return_msg =. CRLF, 'your J command: ', CRLF, a_client_j_cmd, CRLF, ' resulted in error.', CRLF
end.
return_msg
)

NB. ====================================================================================================
start_port_monitor =: 3 : 0
NB. default port 1500, rec buf size 100000 bytes

PORT_FOR_SERVER    =: ". HOST_PORT
SDRECV_BUFFER_SIZE =: ". '100000'

NB. 受信ループでゼロ長のメッセージが来た時にここに戻る
label_skip.

NB. ソケットの初期化 (ソケット使用開始前に必須の処理)
sdcleanup ''

    print 'jsocket reset done'
NB. print 'ソケット情報がリセットされました '

NB. 接続用ソケットの新設
SKLISTEN =: 0 pick sdcheck sdsocket''

    print 'socket number for connection is ',' ', (":SKLISTEN)
NB. print '接続用ソケット番号は',' ', (":SKLISTEN), ' ', 'です '

NB. 接続用ソケットをバインドするポートの再利用を可能にするコマンド
sdcheck sdsetsockopt SKLISTEN, SOL_SOCKET, SO_REUSEADDR, 1

NB. 接続用ソケットを指定されたポートにバインドする
sdcheck sdbind SKLISTEN ; AF_INET_jsocket_ ; '' ; PORT_FOR_SERVER

    print  'communication socket' , ' ', (":SKLISTEN), ' has been binded at ', ' '
NB. print  '通信用ソケット', ' ', (":SKLISTEN), ' を指定ポート', ' '
    print (": PORT_FOR_SERVER)
NB. print (": PORT_FOR_SERVER), ' ', 'にバインドしました  '

NB. クライアントからの接続要求の待機開始
sdcheck sdlisten SKLISTEN , 1

NB. サーバー停止フラグのリセット
server_halt_flag =. 0

NB. 「クライアント接続待ち」、接続後の「受信待ち」のソケット関数はブロッキング関数のため、
NB. 一旦動作すると、プロセスを中断することが出来ないため、クライアントがサーバーを停止出来るよう
NB. このフラグを設置した （プロセスの中断はJbreak.exeで可能ではるが、、、）

NB. クライアントからの接続待ち無限ループ開始 （★）--->呼応する ループの終端にも（★）を記載した
while. 1  do.   

    print  'now waiting for connection request' 
NB. print  'クライアントからの接続待ち状態（無限ループ）に入りました ' 
    print  'at the port: ', ":PORT_FOR_SERVER
NB. print  '待ち受けポート番号: ', ":PORT_FOR_SERVER
    print  'please access at http://127.0.0.1:', (":PORT_FOR_SERVER)
NB. print  'クライアントは http://127.0.0.1:', (":PORT_FOR_SERVER), 'でアクセスして下さい '

    NB. クライアントからの接続要求待機カウンターの初期化
    checkRep =. 0  

    NB. クライアントの接続要求を待機する
    while. 1  do.
        checkRep =. checkRep + 1
        firstItem =. 0 pick sdcheck sdselect ''
        selectStatus =. $ firstItem
        if. (selectStatus = 1) do.
                print 'counter for request on connection: ', ":checkRep
            NB. print '接続リクエスト有無の確認回数：', ":checkRep
                print 'at the port:', ":PORT_FOR_SERVER
            NB. print '接続したポート番号：', ":PORT_FOR_SERVER
                break.  NB. クライアントとの接続が確認できたのでこのループを抜ける
        end.
    end.

    NB. クライアントとの接続完了

    NB. クライアントとの交信の為に、接続用ソケットとは別の通信用ソケットを作成する
    SKSERVER =: 0 pick sdcheck sdaccept SKLISTEN

    print 'connected with a client'
NB. print 'クライアントとの接続完了!'
    print 'now in msg recv mode'
NB. print '以後、メッセージ受信モードに入ります '
    print 'at the socket ',' ', (": SKSERVER)
NB. print '受・送信用ソケット番号は',' ', (": SKSERVER), ' ', 'です '
    print 'server is waiting a message from the client'
NB. print 'サーバーはクライアントからのメッセージを待ち続けます '
    print 'on recieving a msg, it will be processed and reply fmsg will be created.'
NB. print '受信後、応答処理を行い、クライアントへメッセージを送信します '
    print 'until client disconnects or client request server halt'
NB. print 'クライアントが接続を切るか、サーバー停止リスエストをするまで、'
    print 'this loop continues.'
NB. print 'この無限ループを継続します '

    NB. ここからメッセージ受信・処理・応答返信メッセージ送信の無限ループ開始
    
    while. 1  do.  NB. （★★） 無限ループの開始 --> 呼応するループの終端にも（★★）を記載した

           print 'port number: ',(":PORT_FOR_SERVER),' ','socket number: '
       NB. print '通信ポート：',(":PORT_FOR_SERVER),' ','ソケット番号： '
           print (":SKSERVER),' ',' is now in infinite recv/send loop'
       NB. print (":SKSERVER),' ','で受信送信無限ループに入りました '
           print 'sdselect monitoring is as follows'
       NB. print 'sdselect のモニタリング' 

           print 'first  element (socket for read)    => ', ": 0 pick sdcheck sdselect ''  
       NB. print '第１要素 (socket for read)    => ', ": 0 pick sdcheck sdselect ''  
           print 'second element (socket for send)    => ', ": 1 pick sdcheck sdselect ''  
       NB. print '第２要素 (socket for send)    => ', ": 1 pick sdcheck sdselect ''  
           print 'third  element (socket with error ) => ', ": 2 pick sdcheck sdselect ''
       NB. print '第３要素 (socket with error ) => ', ": 2 pick sdcheck sdselect ''

       NB. 受信したメッセージを MSG_FROM_CLIENT に代入する
       MSG_FROM_CLIENT =: sdrecv_one_msg 0 NB. 補助関数

       NB. client message arrived
       TOTAL_BYTE_RECEIVED_IN_STR  =: ": $ MSG_FROM_CLIENT
       NB. print '受信したメッセージのバイト数： ', TOTAL_BYTE_RECEIVED_IN_STR, ' Byte(s)'
           print 'total bytes of recieved message: ', TOTAL_BYTE_RECEIVED_IN_STR, ' Byte(s)'

       NB. 受信メッセージのモニター表示
           print '==========='
       NB. print 'Client -> Server へのメッセージ'
           print 'Client -> Server'
           print '==========='
           print  MSG_FROM_CLIENT
           print '==========='
    
       NB. 受信メッセージの長さがゼロか否かのチェック
       if. (($ MSG_FROM_CLIENT) = 0) do.
           NB. クライアントが接続を切ると長さがゼロの受信データとして戻るので、
           NB. 受信の無限ループを抜けて、一つ上位の接続待ちの無限ループに戻る
           NB. print '受信データサイズがゼロですので通信ループを抜けて接続待ちループに戻ります '
               print 'recv data size is zero, so exit communication loop and back to connect loop'
           NB. break.
           NB. print '受信データゼロの時、ループ離脱でなくサーバースタートに戻ってみる'
	       print 'recv data size zero, just go back to start of server'
	       goto_skip. 
       end.

       NB. 有限長の受信メッセージが届いたので、サーバーとしての処理をする
       NB. ここでは、受信バイト数を計算して、メッセージをエコーバックする
       NB. クライアントがサーバーを停止するコマンド halt を送って来た時、プロセスを終了する。

       NB. 外部での利用のため、ファイルに保存しておく
       NB. MSG_FROM_CLIENT 1!:2 <'client_msg_received.txt'
       MSG_FROM_CLIENT wtf 'client_msg_received.txt'

       if. (+/ 'halt' E. _6{.MSG_FROM_CLIENT) = 1 do.
          NB. a_return_msg =. CRLF, 'サーバー停止コマンド halt を受信しましたので、停止します。', CRLF
              a_return_msg =. CRLF, 'client request halt server, so server will halt.', CRLF
              server_halt_flag =. 1
	      break.  NB.exit from while. loop
       end.
       
       print 'SERVER_MODE is ', SERVER_MODE
       
       if. SERVER_MODE -: 'echo' do.
           a_return_msg =. prepare_response_message_echo_back_mode 0
       end.

       if. SERVER_MODE -: 'jcmd' do.
           a_return_msg =. prepare_response_message_j_one_line_command_mode 0
       end.

       
       NB. クライントへメッセージを返送する sdsendでdomain error が発生することがあるので、try.catch.end.を使う
       try.
         sdcheck a_return_msg sdsend SKSERVER , 0
       catch.
         NB. a_return_msg =. CRLF, 'Domain error が sdsend で発生しました.', CRLF
             a_return_msg =. CRLF, 'Domain error has occurred during sdsend operation.', CRLF
             sdcheck a_return_msg sdsend SKSERVER , 0
       end.
       
       NB. server response msg has been sent via socket

       NB. 以下は送信メッセージのモニター
           print '==========='
       NB. print 'Server -> Client へのメッセージ'
           print 'Server -> Client'
           print '==========='
           print a_return_msg
           print '==========='

       NB. クライアントへ応答メッセージを送信後、クライアントからの次のメッセージ
       NB. を受信する無限ループの先頭に戻る 

    end. NB. （★★）このend. は （★★）印の受信、応答作成、ソケット送信無限ループの end.

    NB. クライアントからサーバー停止のリクエストが届いた場合は
    NB. server_halt_flagがセットされて、ループを抜けてこの位置に来るので
    NB. そのフラッグ判定する

    if. (server_halt_flag = 1) do.
      NB. print 'クライアントからサーバー停止のリクエストがありましたのでサーバーを停止します '
          print 'server will halt on recieving client request to halt.'
          NB. (繰り返しになるがサーバーがハングした場合はJBreakを使えば停止できる)
          NB. クライアントによるサーバー停止コマンドの通知を受けてサーバーを停止させる
          break.
          NB. このbreakで、接続待機の無限ループを抜けてサーバー停止となる   
    end.
end.  NB. （★）この end. は 接続待機の無限ループ （★）印 の end.

NB. サーバー停止リクエストで接続ループを抜けたので、アプリ終了処理へ進む 

NB. ソケット環境をクリーンアップして終了
sdcheck sdcleanup ''

NB.print 'クライアントのリクエストによりサーバーを停止しました ' 
   print 'server has stopped on client request.' 
1
)

NB. ------------------------------
NB. --- main script for server ---
NB. ------------------------------

NB. ====================================================================================================
jsocket_simple_server_menu =: 3 : 0
while. 1 do.
    disp_port_monitor_server_menu 0
    your_cmd =. keyin 8
    one_chr_menu_selection_server_mode your_cmd

        print CRLF,'your selection is ', COMMAND_NAME
    NB. print CRLF,'選択されたコマンドは ', COMMAND_NAME, ' です'
    NB. print CRLF,'enter key で次に進みます'
    NB. dummy =. keyin 8

    if. COMMAND_NAME -: 'exit_menu' do.
       break.  NB. exit from this function
    else.
       try.
          NB. execute COMMAND_NAME
          a_cmd =. COMMAND_NAME, ' 0'
          ". a_cmd
       catch.
              print 'error occurred during the operation'
          NB. print '処理中にエラーが発生しました。'
	      print 'enter key to go back to menu'
          NB. print 'enter key でメニューに戻ります'
	      dummy =. keyin 8
       end.
    end.
end.
   print 'simple server menu is exited'
NB.print 'simple server管理メニューを終了しました。'
sdcleanup ''
print 'type in ',CRLF, 'start_simple_server 0 to resume service'
print '   start_simple_server 0 or'
print '   sss 0'
1
)

NB. ====================================================================================================
NB. alternative definition
start_simple_server =: jsocket_simple_server_menu
sss                 =: jsocket_simple_server_menu

NB. ====================================================================================================
NB. print the following message on loading
print 'type in ',CRLF, 'start_simple_server 0 to begin'
print '   start_simple_server 0 or'
print '   sss 0'
